module Headmin
  module Ckeditor
    def handle_upload
      blob = ActiveStorage::Blob.create_after_upload!(
        io: upload_params[:upload],
        filename: upload_params[:upload].original_filename,
        content_type: upload_params[:upload].content_type
      )
      render json: {
        urls: {
          "default": url_for(blob.variant(resize_to_limit: [1600, 1600], quality: 75)),
          "800": url_for(blob.variant(resize_to_limit: [800, 800], quality: 75)),
          "1024": url_for(blob.variant(resize_to_limit: [1024, 1024], quality: 75)),
          "1600": url_for(blob.variant(resize_to_limit: [1600, 1600], quality: 75))
        }
      }
    end

    private

    def upload_params
      params.permit(
        :upload, :locale
      )
    end
  end
end
