import {Controller} from "stimulus"
import {Headmin} from "../headmin";

export default class extends Controller {
    static get values() {
        return {
            id: String
        }
    }
    static get targets() {
        return ["links", "template"]
    }

    add_association(event) {
        event.preventDefault()

        let html = this.getTemplateHTML()
        html = this.replaceIdsWithTimestamps(html)
        this.addNewRow(html)
    }

    getTemplateHTML() {
        return this.templateTarget.innerHTML
    }

    replaceIdsWithTimestamps(html) {
        const regex = new RegExp(this.idValue, "g");
        return html.replace(regex, new Date().getTime())
    }

    addNewRow(html) {
        this.linksTarget.insertAdjacentHTML('beforebegin', html)
        Headmin.initPlugins()
    }
}
