import {Controller} from "stimulus"
import {Headmin} from '../headmin'

export default class extends Controller {
    static get targets() {
        return ["row"]
    }

    add_association(event) {
        event.preventDefault()

        let html = this.getTemplateHTML()
        html = this.replaceIdsWithTimestamps(html)
        this.addRow(html)
    }

    remove_association(event) {
        event.preventDefault()

        let row = event.target.closest(".repeater-row")

        if (row.dataset.newRecord === "true") {
            // New records are simply removed from the page
            row.remove()
        } else {
            // Existing records are hidden and flagged for deletion
            row.querySelector("input[name*='_destroy']").value = 1
            row.style.display = 'none'
        }
    }

    addRow(html) {
        this.rowTarget.insertAdjacentHTML('afterend', html)
        Headmin.initPlugins()
    }

    replaceIdsWithTimestamps(html) {
        const regex = new RegExp(this.idValue(), "g");
        return html.replace(regex, new Date().getTime())
    }

    getTemplateHTML() {
        const templateTarget = this.templateTarget()
        return templateTarget.innerHTML
    }

    templateTarget() {
        return this.rowTarget.closest('.repeater').querySelector('[data-repeater-target="template"]')
    }

    idValue() {
        return this.rowTarget.closest('.repeater').dataset.repeaterIdValue
    }
}
