import {Controller} from "stimulus"
import Sortable from "sortablejs";
import Rails from "@rails/ujs";

export default class extends Controller {
    static get values() {
        return {url: String}
    }

    static get targets() {
        return ["table", "body"]
    }

    connect() {
        new Sortable(this.bodyTarget, {
            handle: '.table-drag-sort-handle',
            onEnd: (event) => {
                Rails.ajax({
                    url: this.urlValue,
                    type: "PATCH",
                    data: this.getIdsDataString(),
                });
            }
        })
    }

    getIdsDataString() {
        const table = this.tableTarget
        let data = ""
        const handles = [...table.querySelectorAll(".table-drag-sort-handle")]
        handles.map(handle => {
            data += `ids[]=${handle.dataset.id}&`
        })
        return data
    }
}
