const path = require("path");

module.exports = {
    mode: 'development',
    entry: `./src/js/headmin.js`,
    output: {
        path: path.join(__dirname, 'dist/js'),
        filename: 'headmin.js'
    },
    module: {
        rules: [
            {
                test:/\.css$/,
                use:['style-loader','css-loader']
            },
            {
                test: /\.js$/,
                exclude: /node_modules\/(?!bullets-js)/,
                use: {
                    loader: 'babel-loader',
                    options: {
                        presets: [
                            ['@babel/preset-env', { targets: "defaults" }]
                        ]
                    }
                }
            }
        ]
    }
};
